<%@ Page Language="C#" AutoEventWireup="true" CodeFile="Grid.aspx.cs" Inherits="Grid" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title>Expand/Collapse</title>
    <link href="CSS/StyleSheet.css" rel="stylesheet" type="text/css" />

    <script type="text/javascript">
        var Grid = null;
        var UpperBound = 0;
        var LowerBound = 1;
        var CollapseImage = 'Images/minus.gif';
        var ExpandImage = 'Images/plus.gif';
        var Rows = null;
        var n = 1;
        var TimeSpan = 25;
        
        window.onload = function()
        {
            Grid = document.getElementById('<%= this.gvTab.ClientID %>');
            UpperBound = parseInt('<%= this.gvTab.Rows.Count %>');
            Rows = Grid.getElementsByTagName('tr');
        }
        
        function Toggle(Image, Index)
        {
            ToggleImage(Image, Index);  
            ToggleColumns(Image, Index);
        }
        
        function ToggleImage(Image, Index)
        {
            if(Image.IsExpanded == undefined || Image.IsExpanded)
            {
                Image.src = ExpandImage;
                Image.title = 'Expand';
                n = UpperBound;
                
                Image.IsExpanded = false;
            }
            else
            {
                Image.src = CollapseImage;
                Image.title = 'Collapse';
                n = LowerBound;
                
                Image.IsExpanded = true;
            }
        }     
  
        function ToggleColumns(Image, Index)
        {
            if (n < LowerBound || n > UpperBound)  return;
                            
            Rows[n].getElementsByTagName('td')[Index].style.visibility = Rows[n].getElementsByTagName('td')[Index].style.visibility == '' || Rows[n].getElementsByTagName('td')[Index].style.visibility == 'visible' ? 'hidden' : 'visible';
            if(Image.IsExpanded) n++; else n--;
            setTimeout(function(){ToggleColumns(Image, Index);},TimeSpan);
        }

    </script>

</head>
<body>
    <form id="form1" runat="server">
        <div>
            <asp:GridView ID="gvTab" CssClass="Grid" runat="server" AutoGenerateColumns="False"
                ShowFooter="True" GridLines="Vertical">
                <Columns>
                    <asp:TemplateField>
                        <HeaderTemplate>
                            <asp:Image ID="imgN" onclick="javascript:Toggle(this,0);" runat="server" ImageUrl="~/Images/minus.gif"
                                ToolTip="Collapse" ImageAlign="AbsMiddle" />
                            <asp:Label ID="lblHeaderN" runat="server" Text="n"></asp:Label>
                        </HeaderTemplate>
                        <ItemTemplate>
                            <asp:Label ID="lblItemN" runat="server" Text='<%# Eval("n") %>'></asp:Label>
                        </ItemTemplate>
                        <HeaderStyle Width="50px" />
                        <ItemStyle Width="50px" />
                    </asp:TemplateField>
                    <asp:TemplateField>
                        <HeaderTemplate>
                            <asp:Image ID="imgSqrt" onclick="javascript:Toggle(this,1);" runat="server" ImageUrl="~/Images/minus.gif"
                                ToolTip="Collapse" ImageAlign="AbsMiddle" />
                            <asp:Label ID="lblHeaderSqrt" runat="server" Text="sqrt(n)"></asp:Label>
                        </HeaderTemplate>
                        <ItemTemplate>
                            <asp:Label ID="lblItemSqrt" runat="server" Text='<%# Eval("sqrtn") %>'></asp:Label>
                        </ItemTemplate>
                        <HeaderStyle Width="150px" />
                        <ItemStyle Width="150px" />
                    </asp:TemplateField>
                    <asp:TemplateField>
                        <HeaderTemplate>
                            <asp:Image ID="imgQbrt" onclick="javascript:Toggle(this,2);" runat="server" ImageUrl="~/Images/minus.gif"
                                ToolTip="Collapse" ImageAlign="AbsMiddle" />
                            <asp:Label ID="lblHeaderQbrt" runat="server" Text="qbrt(n)"></asp:Label>
                        </HeaderTemplate>
                        <ItemTemplate>
                            <asp:Label ID="lblItemQbrt" runat="server" Text='<%# Eval("qbrtn") %>'></asp:Label>
                        </ItemTemplate>
                        <HeaderStyle Width="150px" />
                        <ItemStyle Width="150px" />
                    </asp:TemplateField>
                </Columns>
                <HeaderStyle CssClass="Header" />
                <RowStyle CssClass="Row" />
                <AlternatingRowStyle CssClass="AlternateRow" />
                <FooterStyle CssClass="Footer" />
            </asp:GridView>
        </div>
    </form>
</body>
</html>
